/**
 ****************************************************************************************************
 * @file          HC_SR04.c
 * @author   YUQI
 * @version  V1.0
 * @date        2023-05-01
 * @brief        
 * @license
 ****************************************************************************************************
 * @attention
 * HC-SR04ģEchoŽGPIOB6;HC-SR04ģTrigŽGPIOB5
 * ʵƽ̨: CH32V203C8T6
 *
 ****************************************************************************************************
 */

#include "debug.h"
#include "HC_SR04.h"

uint64_t time=0;                                                     /* ʱ */
uint64_t time_end=0;                                            /* 洢زźʱ */

/**
 * @brief  ʼHC_SR04IO, ʹʱ
 * @param  
 * @retval 
 */
void HC_SR04_Init(void)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);    /* ʱʹ */

    GPIO_InitTypeDef GPIO_InitStructure;                                                   /* ṹ */
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;                      /*  */
    GPIO_InitStructure.GPIO_Pin = Trig;                                                       /* GPIO */
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;                    /*  */
    GPIO_Init(GPIOB,&GPIO_InitStructure);                                                /* ʼPB5 */

    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;                            /*  */
    GPIO_InitStructure.GPIO_Pin = Echo;                                                     /* GPIO */

    GPIO_Init(GPIOB,&GPIO_InitStructure);                                               /* ʼPB6 */

    GPIO_WriteBit(GPIOB,Trig,Bit_RESET);                                                /* PB5Trig˿λʼֵд0 */

    Delay_Us(15);                                                                                                /* ʱ15us */

}

/**
 * @brief  벢صλΪ׵ľ
 * @param  
 * @retval Distance_mm
 */
int16_t sonar_mm(void)
{
    uint32_t Distance,Distance_mm = 0;                                                     /* ʼֵDistance;Distance_mmΪ0 */
    GPIO_WriteBit(GPIOB,Trig,Bit_SET);                                                     /* PB5Trig˿λʼֵд1 */
    Delay_Us(15);                                                                                                /* ʱ15us */
    GPIO_WriteBit(GPIOB,Trig,Bit_RESET);                                                /* PB5Trig˿λʼֵд0 */
    while(GPIO_ReadInputDataBit(GPIOB,Echo)==Bit_RESET);        /* ȴ͵ƽ */
    time=0;                                                                                                            /* ʱ */
    while(GPIO_ReadInputDataBit(GPIOB,Echo)==Bit_SET);              /* ȴߵƽ */
    time_end=time;                                                                                             /* ¼ʱʱ */
    if(time_end/100<38)                                                                                  /* жǷС38룬38ľǳʱֱӵ淵0 */
    {
        Distance=(time_end*346)/2;                                                               /* 룬25CеΪ346m/s */
        Distance_mm=Distance/100;                                                               /* time_endĵλ10us100óλΪ׵ľ */
    }
    return Distance_mm;                                                                                  /* ز */
}
/**
 * @brief  벢صλΪ׵ľ
 * @param  
 * @retval Distance_m
 */
float sonar(void)
{
    uint32_t Distance,Distance_mm = 0;                                                        /* ʼֵDistance;Distance_mmΪ0 */
    float Distance_m=0;                                                                                       /* ʼֵDistance_mΪ0 */
    GPIO_WriteBit(GPIOB,Trig,Bit_SET);                                                        /* PB5Trig˿λʼֵд1 */
    Delay_Us(15);                                                                                                   /* ʱ15us */
    GPIO_WriteBit(GPIOB,Trig,Bit_RESET);                                                   /* PB5Trig˿λʼֵд0 */
    while(GPIO_ReadInputDataBit(GPIOB,Echo)==Bit_RESET);           /* ȴ͵ƽ */
    time=0;                                                                                                               /* ʱ */
    while(GPIO_ReadInputDataBit(GPIOB,Echo)==Bit_SET);                /* ȴߵƽ */
    time_end=time;                                                                                               /* ¼ʱʱ */
    if(time_end/100<38)                                                                                    /* жǷС38룬38ľǳʱֱӵ淵0 */
    {
        Distance=(time_end*346)/2;                                                                 /* 룬25CеΪ346m/s */
        Distance_mm=Distance/100;                                                                 /* time_endĵλ10us100óλΪmmľ */
        Distance_m=Distance_mm/1000;                                                         /* Distance_mmĵλmm100óλΪmľ */
    }
    return Distance_m;                                                                                        /* زΪm */
}

/**
 * @brief  ж3
 * @param  жϺʱÿ10΢time1
 * @retval 
 */
void TIM3_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM3, TIM_IT_Update) == SET)                          /* ж϶ʱTIM3жϱ־λǷλ */
    {
        time++;                                                                                                           /* ʱ1 */
        TIM_ClearITPendingBit(TIM3, TIM_IT_Update);                              /* жϱ־λ */
    }
}
