/**
 ****************************************************************************************************
 * @file              Timer.c
 * @author       YUQI
 * @version      V1.0
 * @date            2022-05-01
 * @brief           
 * @license
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:CH32V203C8T6
 *
 ****************************************************************************************************
 */

#include "Timer.h"
#include "ch32v20x_conf.h"
/**
 * @brief  ʱʼ
 * @param  
 * @retval 
 */
void Timer_Init(void)
{
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3,ENABLE);                  /* ʱʹ */

    TIM_InternalClockConfig(TIM3);                                       /* ѡʱԪʱ */

    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;                   /* ʱԪ */

    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;          /* ʱӷƵ,Ϊ1Ƶ(Ƶ) */
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;      /* öʱļģʽΪϼ */
    TIM_TimeBaseInitStructure.TIM_Period = 10-1;                         /* ʱļ;ֵ,ﵽֵ¼,0ʼ,Լ1010-1,ÿ10΢봥һ */
    TIM_TimeBaseInitStructure.TIM_Prescaler = 72-1;                      /* ʱԤƵֵ,72-1ÿ ʱƵ(72Mhz)/72=1000000 ʱڼ1,ÿ1΢+1 */
    TIM_TimeBaseInitStructure.TIM_RepetitionCounter = 0;                 /* ʱظֵ */

    TIM_TimeBaseInit(TIM3,&TIM_TimeBaseInitStructure);                   /* ʼʱ3Ļ */

    TIM_ClearFlag(TIM3,TIM_FLAG_Update);                                 /* жϱ־λ */

    TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE);                             /* ʹTIMʱж;ж */

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);                      /* жϿȼ */

    NVIC_InitTypeDef NVIC_InitStructure;                                 /* жϿ */

    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;                      /* жϿжͨ */
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;                      /* жϿжʹ */
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;            /* жϿȼ */
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;                   /* жϿӦȼ */

    NVIC_Init(&NVIC_InitStructure);                                      /* ǶжϿʼ */

    TIM_Cmd(TIM3,ENABLE);                                                /* ʹܶʱļ */

}
