/**
 ********************************* (C) COPYRIGHT ******************************
 * File Name            : main.c
 * Author                  : YUQI
 * Version                : V1.0.0
 * Date                      : 2023/06/06
 * Description        : Main program body.
*********************************************************************************
* Attention:
* ʵƽ̨: CH32V203C8T6
* This software (modified or not) and binary are used for
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*********************************************************************************
*/
#include "ch32v20x_conf.h"
#include "ch32v20x.h"
#include "HC_SR04.h"
#include "Timer.h"
#include "debug.h"
#include "OLED.h"

/**
 * @brief  ֵĳ
 * @param  
 * @retval len
 */
uint64_t numlen(uint64_t num)
{
    uint64_t len = 1;                                                                   /* ʼΪ1 */
    for(; num > 9; ++len)                                                               /* жnumǷ9򳤶+1 */
    num /= 10;                                                                          /* ʹó㣬ֱnumС1 */
    return len;                                                                         /* سȵֵ */
}

/********************************************************************************
 * @fn      main
 *@Noteʵ
 * @brief   Main program.
 *
 * @return  none
 *********************************************************************************
 */

int main(void)
{
    OLED_Init();                                                                        /* ʼOLED */
    Timer_Init();                                                                       /* ʼʱ */
    HC_SR04_Init();                                                                     /* ʼģ */

    OLED_ShowString(1, 1, "Distance:");                                                 /* OLEDַ */

    while (1)
    {
        int Distance_mm=sonar_mm();                                                     /* ȡλףmm */
        int Distance_m=Distance_mm/1000;                                                /* תΪףmΪλַDistance_m */
        int Distance_m_p=Distance_mm%1000;                                              /* תΪףmΪλСַDistance_m_p */
        OLED_Clear_Part(2,1,16);                                                        /* OLDE2 */
        OLED_ShowNum(2, 1,Distance_m,numlen(Distance_m));                               /* ʾ */
        OLED_ShowChar(2, 1+numlen(Distance_m), '.');                                    /* ʾС */
        if(Distance_m_p<100)                                                            /* жǷС100 */
        {
            OLED_ShowChar(2, 1+numlen(Distance_m)+1,'0');                               /* ΪλףС10cmʱҪ0 */
            OLED_ShowNum(2, 1+numlen(Distance_m)+2,Distance_m_p,numlen(Distance_m_p));  /* ʾС */
            OLED_ShowChar(2, 1+numlen(Distance_m)+2+numlen(Distance_m_p), 'm');         /* ʾλ */
        }
        else
        {
            OLED_ShowNum(2, 1+numlen(Distance_m)+1,Distance_m_p,numlen(Distance_m_p)); /* ʾС */
            OLED_ShowChar(2, 1+numlen(Distance_m)+1+numlen(Distance_m_p), 'm');        /* ʾλ */
        }
        OLED_Clear_Part(3,1,16);                                                       /* OLDE3 */
        OLED_ShowNum(3, 1,Distance_mm,numlen(Distance_mm));                            /* ʾλΪ׵ľ */
        OLED_ShowString(3, 1 + numlen(Distance_mm), "mm");                             /* OLEDַ */
        Delay_Ms(300);                                                                 /* ʱ300 */
    }
}
